#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define A 4321
#define B 5678
#define P 999149
#define LEN 100

typedef struct _Node{
	char* val;
	struct _Node* next;
} Node;
typedef Node* List;

int hash(char* s, int n){
	int v=0, i=0;
	for(i=0;s[i];i++) v += (int)s[i];
	return ((A*v + B)%P) % n;
}

int main()
{
	int N,i;
	scanf("%d",&N);
	
	List* table = (List*) calloc(2*N, sizeof(List));
	
	//INSERIMENTO
	for(i=0; i<N; i++)
	{
		Node* n = (Node*) malloc(sizeof(Node));
		n->val = (char*) malloc((LEN+1)*sizeof(char));
		scanf("%s", n->val);
		int h = hash(n->val, 2*N);
		n->next = table[h];
		table[h] = n;
	}

	//RICERCA
	int M;
	char* s;
	scanf("%d", &M);
	for(i=0; i<M; i++)
	{
		s = (char*) malloc(sizeof(char)*(LEN+1));
		scanf("%s", s);
		int h = hash(s, 2*N);
		int c = 0;
		Node* n = table[h];
		while(n != NULL){
			if (strcmp(s, n->val) < 0) c++;
			n = n->next;
		}
		printf("%d\n", c);
	}		
}